#!/usr/bin/python
#
# Copyright 2007 Red Hat, Inc.
#
# This software may be freely redistributed under the terms of the GNU
# general public license.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

try:
    import dbus
except ImportError:
    pass
else:
    if getattr(dbus, 'version', (0,0,0) >= (0,40,0)):
        new_api = True
    else:
        new_api = False

def get_interface(bus, service, object, interface):
    iface = None
    if new_api: # newer api: get_object(), dbus.Interface()
        proxy = bus.get_object(service, object)
        iface = dbus.Interface(proxy, interface)
    else:       # deprecated api: get_service(), get_object()
        svc = bus.get_service(service)
        iface = svc.get_object(object, interface)
    return iface
