#!/usr/bin/python
#
# Copyright 2007 Red Hat, Inc.
#
# This software may be freely redistributed under the terms of the GNU
# general public license.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import os, httplib

def create_tar(filelist):
    fl=""
    for i in filelist:
        if not i[0] == '/':
            print "Path %s is not absolute, skipping." % i
            continue
        if os.path.exists(i):
            fl = fl + " %s" % i[1:]
        else:
            print "Path %s does not exist, skipping." % i
    if not fl: return False
    try:
        data = os.popen('tar -cp -C / -f - %s' % fl).read()
    except:
        return False
    else:
        return data

def save(server, path, filelist, machineid):
    data = create_tar(filelist)
    if not data: return
    http = httplib.HTTPConnection(server.replace('http://',''))
    headers = {'Content-type':'application/octet-stream', \
               'Content-Length':str(len(data)), 'User-Agent':'snake-client',\
               'X-SNAKE-MachineID':machineid}
    http.request('PUT', path, data, headers)
    response = http.getresponse()
    if response.status in (301, 302):
        print "Resource had moved to %s" % response.headers['Location']
    elif not response.status in (200, 201, 204):
        print "Remote host returned: %s %s" % (response.status, response.reason)
    response.close()
    return

def restore(server, path, machineid):
    http = httplib.HTTPConnection(server.replace('http://',''))
    http.putrequest('GET', "/files/%s/files.tar" % machineid)
    http.putheader('Accept','*/*')
    http.endheaders()
    response = http.getresponse()
    data = response.read()
    if response.status == 200:
        os.popen('tar -xp -C / -f -', 'w').write(data)
    else:
        print "Remote host returned: %s %s" % (response.status, response.reason)
    response.close()
    return
